Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap01

	Public Class Chap0112

		Public Sub New()
			Console.WriteLine("Chapter 1 example 12: reading an existing PDF file")
			Try
				Dim reader As PdfReader = New PdfReader("Chap0703.pdf")
				Dim n As Integer = reader.NumberOfPages
				Dim psize As Rectangle = reader.GetPageSize(1)
				Dim width As Single = psize.Width
				Dim height As Single = psize.Height
				Dim doc As Document = New Document(psize, 50, 50, 50, 50)
				Dim writer As PdfWriter = PdfWriter.GetInstance(doc, New FileStream("Chap0112.pdf", FileMode.Create))
				Try
					Dim watermark As Watermark = New Watermark(Image.GetInstance("watermark.jpg"), 200, 320)
					doc.Add(watermark)
				Catch e As Exception
					Console.Error.WriteLine("Are you sure you have the file 'watermark.jpg' in the right path?")
				End Try
				doc.Open
				Dim cb As PdfContentByte = writer.DirectContent
				Dim i As Integer = 0
				Dim p As Integer = 0
				Console.WriteLine("There are " + n + " pages in the doc.")
				While i < n
					doc.NewPage
					System.Math.Min(System.Threading.Interlocked.Increment(p),p-1)
					System.Math.Min(System.Threading.Interlocked.Increment(i),i-1)
					Dim page1 As PdfImportedPage = writer.GetImportedPage(reader, i)
					cb.AddTemplate(page1, 0.5F, 0, 0, 0.5F, 0, height / 2)
					Console.WriteLine("processed page " + i)
					If i < n Then
						System.Math.Min(System.Threading.Interlocked.Increment(i),i-1)
						Dim page2 As PdfImportedPage = writer.GetImportedPage(reader, i)
						cb.AddTemplate(page2, 0.5F, 0, 0, 0.5F, width / 2, height / 2)
						Console.WriteLine("processed page " + i)
					End If
					If i < n Then
						System.Math.Min(System.Threading.Interlocked.Increment(i),i-1)
						Dim page3 As PdfImportedPage = writer.GetImportedPage(reader, i)
						cb.AddTemplate(page3, 0.5F, 0, 0, 0.5F, 0, 0)
						Console.WriteLine("processed page " + i)
					End If
					If i < n Then
						System.Math.Min(System.Threading.Interlocked.Increment(i),i-1)
						Dim page4 As PdfImportedPage = writer.GetImportedPage(reader, i)
						cb.AddTemplate(page4, 0.5F, 0, 0, 0.5F, width / 2, 0)
						Console.WriteLine("processed page " + i)
					End If
					cb.SetRGBColorStroke(255, 0, 0)
					cb.MoveTo(0, height / 2)
					cb.LineTo(width, height / 2)
					cb.Stroke
					cb.MoveTo(width / 2, height)
					cb.LineTo(width / 2, 0)
					cb.Stroke
					Dim bf As BaseFont = BaseFont.CreateFont(BaseFont.HELVETICA, BaseFont.CP1252, BaseFont.NOT_EMBEDDED)
					cb.BeginText
					cb.SetFontAndSize(bf, 14)
					cb.ShowTextAligned(PdfContentByte.ALIGN_CENTER, "page " + p + " of " + ((n / 4) + (Microsoft.VisualBasic.IIf(n Mod 4 > 0,1,0))), width / 2, 40, 0)
					cb.EndText
				End While
				doc.Close
			Catch de As Exception
				Console.Error.WriteLine(de.Message)
				Console.Error.WriteLine(de.StackTrace)
			End Try
		End Sub
	End Class 
End Namespace
