Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap01

	Public Class Concat

		Public Sub New(ByVal args As String())
			If args.Length < 3 Then
				Console.Error.WriteLine("This tools needs at least 3 parameters:" & Microsoft.VisualBasic.Chr(10) & "java Concat destfile file1 file2 [file3 ...]")
			Else
				Try
					Dim f As Integer = 1
					Dim reader As PdfReader = New PdfReader(args(f))
					Dim n As Integer = reader.NumberOfPages
					Console.WriteLine("There are " + n + " pages in the original file.")
					Dim doc As Document = New Document(reader.GetPageSizeWithRotation(1))
					Dim writer As PdfWriter = PdfWriter.GetInstance(doc, New FileStream(args(0), FileMode.Create))
					doc.Open
					Dim cb As PdfContentByte = writer.DirectContent
					Dim page As PdfImportedPage
					Dim rotation As Integer
					While f < args.Length
						Dim i As Integer = 0
						While i < n
							System.Math.Min(System.Threading.Interlocked.Increment(i),i-1)
							doc.SetPageSize(reader.GetPageSizeWithRotation(i))
							doc.NewPage
							page = writer.GetImportedPage(reader, i)
							rotation = reader.GetPageRotation(i)
							If rotation = 90 OrElse rotation = 270 Then
								cb.AddTemplate(page, 0, -1F, 1F, 0, 0, reader.GetPageSizeWithRotation(i).Height)
							Else
								cb.AddTemplate(page, 1F, 0, 0, 1F, 0, 0)
							End If
							Console.WriteLine("Processed page " + i)
						End While
						System.Math.Min(System.Threading.Interlocked.Increment(f),f-1)
						If f < args.Length Then
							reader = New PdfReader(args(f))
							n = reader.NumberOfPages
							Console.WriteLine("There are " + n + " pages in the original file.")
						End If
					End While
					doc.Close
				Catch e As Exception
					Console.Error.WriteLine(e.Message)
					Console.Error.WriteLine(e.StackTrace)
				End Try
			End If
		End Sub
	End Class 
End Namespace
