Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap01

	Public Class Encrypt

		Public Sub New(ByVal args As String())
			If Not (args.Length = 3) Then
				Console.Error.WriteLine("This tools needs 3 parameters:" & Microsoft.VisualBasic.Chr(10) & "java Encrypt srcfile destfile password")
			Else
				Try
					Dim reader As PdfReader = New PdfReader(args(0))
					Dim n As Integer = reader.NumberOfPages
					Console.WriteLine("There are " + n + " pages in the original file.")
					Dim doc As Document = New Document(reader.GetPageSizeWithRotation(1))
					Dim writer As PdfWriter = PdfWriter.GetInstance(doc, New FileStream(args(1), FileMode.Create))
					writer.SetEncryption(PdfWriter.STRENGTH128BITS, args(2), Nothing, PdfWriter.AllowPrinting)
					doc.Open
					Dim cb As PdfContentByte = writer.DirectContent
					Dim page As PdfImportedPage
					Dim rotation As Integer
					Dim i As Integer = 0
					While i < n
						System.Math.Min(System.Threading.Interlocked.Increment(i),i-1)
						doc.SetPageSize(reader.GetPageSizeWithRotation(i))
						doc.NewPage
						page = writer.GetImportedPage(reader, i)
						rotation = reader.GetPageRotation(i)
						If rotation = 90 OrElse rotation = 270 Then
							cb.AddTemplate(page, 0, -1F, 1F, 0, 0, reader.GetPageSizeWithRotation(i).Height)
						Else
							cb.AddTemplate(page, 1F, 0, 0, 1F, 0, 0)
						End If
						Console.WriteLine("Processed page " + i)
					End While
					doc.Close
				Catch e As Exception
					Console.Error.WriteLine(e.Message)
					Console.Error.WriteLine(e.StackTrace)
				End Try
			End If
		End Sub
	End Class 
End Namespace
