Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap01

	Public Class Split

		Public Sub New(ByVal args As String())
			If Not (args.Length = 4) Then
				Console.Error.WriteLine("This tools needs 4 parameters:" & Microsoft.VisualBasic.Chr(10) & "java Split srcfile destfile1 destfile2 pagenumber")
			Else
				Try
					Dim pagenumber As Integer = Integer.Parse(args(3))
					Dim reader As PdfReader = New PdfReader(args(0))
					Dim n As Integer = reader.NumberOfPages
					Console.WriteLine("There are " + n + " pages in the original file.")
					If pagenumber < 2 OrElse pagenumber > n Then
						Throw New DocumentException("You can't split this doc at page " + pagenumber + "; there is no such page.")
					End If
					Dim document1 As Document = New Document(reader.GetPageSizeWithRotation(1))
					Dim document2 As Document = New Document(reader.GetPageSizeWithRotation(pagenumber))
					Dim writer1 As PdfWriter = PdfWriter.GetInstance(document1, New FileStream(args(1), FileMode.Create))
					Dim writer2 As PdfWriter = PdfWriter.GetInstance(document2, New FileStream(args(2), FileMode.Create))
					document1.Open
					Dim cb1 As PdfContentByte = writer1.DirectContent
					document2.Open
					Dim cb2 As PdfContentByte = writer2.DirectContent
					Dim page As PdfImportedPage
					Dim rotation As Integer
					Dim i As Integer = 0
					While i < pagenumber - 1
						System.Math.Min(System.Threading.Interlocked.Increment(i),i-1)
						document1.SetPageSize(reader.GetPageSizeWithRotation(i))
						document1.NewPage
						page = writer1.GetImportedPage(reader, i)
						rotation = reader.GetPageRotation(i)
						If rotation = 90 OrElse rotation = 270 Then
							cb1.AddTemplate(page, 0, -1F, 1F, 0, 0, reader.GetPageSizeWithRotation(i).Height)
						Else
							cb1.AddTemplate(page, 1F, 0, 0, 1F, 0, 0)
						End If
					End While
					While i < n
						System.Math.Min(System.Threading.Interlocked.Increment(i),i-1)
						document2.SetPageSize(reader.GetPageSizeWithRotation(i))
						document2.NewPage
						page = writer2.GetImportedPage(reader, i)
						rotation = reader.GetPageRotation(i)
						If rotation = 90 OrElse rotation = 270 Then
							cb2.AddTemplate(page, 0, -1F, 1F, 0, 0, reader.GetPageSizeWithRotation(i).Height)
						Else
							cb2.AddTemplate(page, 1F, 0, 0, 1F, 0, 0)
						End If
						Console.WriteLine("Processed page " + i)
					End While
					document1.Close
					document2.Close
				Catch e As Exception
					Console.Error.WriteLine(e.Message)
					Console.Error.WriteLine(e.StackTrace)
				End Try
			End If
		End Sub
	End Class 
End Namespace
