Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap02

	Public Class Chap0201a

		Public Sub New()
			Console.WriteLine("Chapter 2 example 1: Horizontal space in Paragraphs")
			Document.Compress = True
			Dim doc As Document = New Document
			Try
				PdfWriter.GetInstance(doc, New FileStream("Chap0201a.pdf", FileMode.Create))
				doc.Open
				Dim fonts(14) As Font
				fonts(13) = FontFactory.GetFont(FontFactory.COURIER, 7, Font.NORMAL)
				fonts(12) = FontFactory.GetFont(FontFactory.COURIER, 14, Font.BOLD)
				fonts(11) = FontFactory.GetFont(FontFactory.COURIER, 8, Font.ITALIC)
				fonts(10) = FontFactory.GetFont(FontFactory.COURIER, 13, Font.BOLD Or Font.ITALIC)
				fonts(9) = FontFactory.GetFont(FontFactory.HELVETICA, 9, Font.NORMAL)
				fonts(8) = FontFactory.GetFont(FontFactory.HELVETICA, 12, Font.BOLD)
				fonts(7) = FontFactory.GetFont(FontFactory.HELVETICA, 12, Font.ITALIC)
				fonts(6) = FontFactory.GetFont(FontFactory.HELVETICA, 11, Font.BOLD Or Font.ITALIC)
				fonts(5) = FontFactory.GetFont(FontFactory.TIMES_ROMAN, 12, Font.NORMAL)
				fonts(4) = FontFactory.GetFont(FontFactory.TIMES_ROMAN, 16, Font.BOLD)
				fonts(3) = FontFactory.GetFont(FontFactory.TIMES_ROMAN, 12, Font.ITALIC)
				fonts(2) = FontFactory.GetFont(FontFactory.TIMES_ROMAN, 32, Font.BOLD Or Font.ITALIC)
				fonts(1) = FontFactory.GetFont(FontFactory.SYMBOL, 5, Font.NORMAL)
				fonts(0) = FontFactory.GetFont(FontFactory.ZAPFDINGBATS, 5, Font.NORMAL)
				Dim i As Integer = 0
				While i < 14
					Dim chunk As Chunk = New Chunk("This is some text in some", fonts(i))
					doc.Add(New Phrase(chunk))
					doc.Add(New Phrase((New Chunk(" font. ", fonts(i))).SetTextRise(Microsoft.VisualBasic.IIf((i Mod 2 = 0),-6,6))))
					System.Math.Min(System.Threading.Interlocked.Increment(i),i-1)
				End While
				doc.Add(New Phrase(New Chunk("This text is underlined ", FontFactory.GetFont(FontFactory.HELVETICA, 12, Font.UNDERLINE))))
				doc.Add(New Phrase(New Chunk("This font is of type ITALIC | STRIKETHRU ", FontFactory.GetFont(FontFactory.HELVETICA, 12, Font.ITALIC Or Font.STRIKETHRU))))
				Dim ck As Chunk = New Chunk(" This text has a yellow background color ", FontFactory.GetFont(FontFactory.HELVETICA, 12))
				ck.SetBackground(New Color(255, 255, 0))
				doc.Add(New Phrase(ck))
				doc.Add(New Chunk("text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text"))
				Dim img As Image = Image.GetInstance("pngnow.png")
				ck = New Chunk(img, 0, 0)
				Dim p1 As Phrase = New Phrase("This is an image (not) hanging into the above text")
				p1.Add(ck)
				p1.Add(" just here.")
				doc.Add(p1)
				p1 = New Phrase
				ck = New Chunk(" As we can see the clashing is fixed for Images and")
				ck.SetBackground(New Color(255, 255, 0))
				p1.Add(ck)
				ck = New Chunk(" oversized font chunks", fonts(2))
				ck.SetBackground(New Color(255, 255, 0))
				p1.Add(ck)
				ck = New Chunk(", but no change of leading is introduced by ")
				ck.SetBackground(New Color(255, 255, 0))
				p1.Add(ck)
				ck = New Chunk("risen ", fonts(7))
				ck.SetBackground(New Color(255, 255, 0))
				p1.Add(ck)
				ck = New Chunk("(i.e. ")
				ck.SetBackground(New Color(255, 255, 0))
				p1.Add(ck)				
				ck = New Chunk("subscript").SetTextRise(-9)
				ck.SetBackground(New Color(255, 255, 0))
				p1.Add(ck)
				ck = New Chunk(" or ")
				
				ck.SetBackground(New Color(255, 255, 0))
				p1.Add(ck)
				ck = New Chunk("superscirpt").SetTextRise(9)
				ck.SetBackground(New Color(255, 255, 0))
				p1.Add(ck)
				ck = New Chunk(") text! ")
				ck.SetBackground(New Color(255, 255, 0))
				p1.Add(ck)
				doc.Add(p1)
				doc.Add(New Chunk(" text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text"))
				ck = New Chunk(img, 0, -19)
				p1 = New Phrase("This is an image (not) hanging in the subsequent text")
				p1.Add(ck)
				p1.Add(" just here.")
				doc.Add(p1)
				doc.Add(New Chunk("text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text"))
				ck = New Chunk(img, 0, -7)
				p1 = New Phrase("This is an image aligned to 'its' baseline ")
				p1.Add(ck)
				p1.Add(" just here.")
				doc.Add(p1)
				doc.Add(New Chunk("text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text text"))
			Catch de As DocumentException
				Console.WriteLine(de.Message)
			Catch ioe As IOException
				Console.WriteLine(ioe.Message)
			End Try
			doc.Close
		End Sub
	End Class 
End Namespace
