Imports System
Imports System.IO
Imports System.Collections
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap02

	Class Glossary
	Inherits PdfPageEventHelper
		Private glossary As SortedList = New SortedList

		Public Overloads Overrides Sub OnGenericTag(ByVal writer As PdfWriter, ByVal document As Document, ByVal rect As Rectangle, ByVal text As String)
			glossary.Add(text, writer.PageNumber)
		End Sub

		Public Function GetGlossary() As SortedList
			Return glossary
		End Function
	End Class 

	Public Class Chap0209

		Public Sub New()
			Console.WriteLine("Chapter 2 example 9: generic tags")
			Dim document As Document = New Document
			Try
				Dim writer As PdfWriter = PdfWriter.GetInstance(document, New FileStream("Chap0209.pdf", FileMode.Create))
				document.Open
				Dim pageEvent As Glossary = New Glossary
				writer.PageEvent = pageEvent
				Dim f(14) As String
				f(0) = "Courier"
				f(1) = "Courier Bold"
				f(2) = "Courier Italic"
				f(3) = "Courier Bold Italic"
				f(4) = "Helvetica"
				f(5) = "Helvetica bold"
				f(6) = "Helvetica italic"
				f(7) = "Helvetica bold italic"
				f(8) = "Times New Roman"
				f(9) = "Times New Roman bold"
				f(10) = "Times New Roman italic"
				f(11) = "Times New Roman bold italic"
				f(12) = "Symbol"
				f(13) = "Zapfdingbats"
				Dim fonts(14) As Font
				fonts(0) = FontFactory.GetFont(FontFactory.COURIER, 12, Font.NORMAL)
				fonts(1) = FontFactory.GetFont(FontFactory.COURIER, 12, Font.BOLD)
				fonts(2) = FontFactory.GetFont(FontFactory.COURIER, 12, Font.ITALIC)
				fonts(3) = FontFactory.GetFont(FontFactory.COURIER, 12, Font.BOLD Or Font.ITALIC)
				fonts(4) = FontFactory.GetFont(FontFactory.HELVETICA, 12, Font.NORMAL)
				fonts(5) = FontFactory.GetFont(FontFactory.HELVETICA, 12, Font.BOLD)
				fonts(6) = FontFactory.GetFont(FontFactory.HELVETICA, 12, Font.ITALIC)
				fonts(7) = FontFactory.GetFont(FontFactory.HELVETICA, 12, Font.BOLD Or Font.ITALIC)
				fonts(8) = FontFactory.GetFont(FontFactory.TIMES_ROMAN, 12, Font.NORMAL)
				fonts(9) = FontFactory.GetFont(FontFactory.TIMES_ROMAN, 12, Font.BOLD)
				fonts(10) = FontFactory.GetFont(FontFactory.TIMES_ROMAN, 12, Font.ITALIC)
				fonts(11) = FontFactory.GetFont(FontFactory.TIMES_ROMAN, 12, Font.BOLD Or Font.ITALIC)
				fonts(12) = FontFactory.GetFont(FontFactory.SYMBOL, 12, Font.NORMAL)
				fonts(13) = FontFactory.GetFont(FontFactory.ZAPFDINGBATS, 12, Font.NORMAL)
				Dim i As Integer = 0
				While i < 14
					Dim chunk As Chunk = New Chunk("This is font ", fonts(i))
					Dim p As Paragraph = New Paragraph(chunk)
					p.Add(New Phrase((New Chunk(f(i), fonts(i))).SetGenericTag(f(i))))
					document.Add(p)
					If i Mod 4 = 3 Then
						document.NewPage
					End If
					System.Math.Min(System.Threading.Interlocked.Increment(i),i-1)
				End While
				document.NewPage
				Dim glossary As SortedList = pageEvent.GetGlossary
				For Each key As String In glossary.Keys
					Dim page As Integer = CType(glossary(key), Integer)
					Dim g As Paragraph = New Paragraph(key)
					g.Add(" : page ")
					g.Add(page.ToString)
					document.Add(g)
				Next
			Catch de As DocumentException
				Console.Error.WriteLine(de.Message)
			Catch ioe As IOException
				Console.Error.WriteLine(ioe.Message)
			End Try
			document.Close
		End Sub
	End Class 
End Namespace
