Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap05

	Public Class Chap0511

		Public Sub New()
			Console.WriteLine("Chapter 5 example 11: avoid table splitting")
			Dim document As Document = New Document
			Try
				PdfWriter.GetInstance(document, New FileStream("Chap0511.pdf", FileMode.Create))
				document.Open
				Dim table As Table = New Table(3)
				table.TableFitsPage = True
				table.BorderWidth = 1
				table.BorderColor = New Color(0, 0, 255)
				table.Padding = 5
				table.Spacing = 5
				Dim cell As Cell = New Cell("header")
				cell.Header = True
				cell.Colspan = 3
				table.AddCell(cell)
				cell = New Cell("example cell with colspan 1 and rowspan 2")
				cell.Rowspan = 2
				cell.BorderColor = New Color(255, 0, 0)
				table.AddCell(cell)
				table.AddCell("1.1")
				table.AddCell("2.1")
				table.AddCell("1.2")
				table.AddCell("2.2")
				table.AddCell("cell test1")
				cell = New Cell("big cell")
				cell.Rowspan = 2
				cell.Colspan = 2
				cell.BackgroundColor = New Color(192, 192, 192)
				table.AddCell(cell)
				table.AddCell("cell test2")
				document.Add(New Paragraph("repeating the same table 10 times:"))
				Dim i As Integer = 0
				While i < 10
					document.Add(table)
					System.Math.Min(System.Threading.Interlocked.Increment(i),i-1)
				End While
			Catch de As DocumentException
				Console.Error.WriteLine(de.Message)
			Catch ioe As IOException
				Console.Error.WriteLine(ioe.Message)
			End Try
			document.Close
		End Sub
	End Class 
End Namespace
