Imports System
Imports System.IO
Imports iTextSharp.text
Imports RtfWriter=iTextSharp.text.rtf.RtfWriter
Imports RtfHeaderFooters=iTextSharp.text.rtf.RtfHeaderFooters
Namespace iTextSharp.tutorial.Chap08

	Public Class Chap0803

		Public Sub New()
			Console.WriteLine("Chapter 8 example 3: RTF with the RtfHeaderFooters class")
			Dim doc As Document = New Document(PageSize.A4)
			Try
				Dim rtf As RtfWriter = RtfWriter.GetInstance(doc, New FileStream("Chap0803.rtf", FileMode.Create))
				rtf.SetHasTitlePage(True)
				Dim header As RtfHeaderFooters = New RtfHeaderFooters
				Dim footer As RtfHeaderFooters = New RtfHeaderFooters
				header.Set(RtfHeaderFooters.FIRST_PAGE, New HeaderFooter(New Phrase("This header is only on the first page"), False))
				header.Set(RtfHeaderFooters.LEFT_PAGES, New HeaderFooter(New Phrase("This header is only on left pages"), False))
				header.Set(RtfHeaderFooters.RIGHT_PAGES, New HeaderFooter(New Phrase("This header is only on right pages. "), False))
				footer.Set(RtfHeaderFooters.LEFT_PAGES, New HeaderFooter(New Phrase("This footer is on all pages except the first. Page: "), True))
				footer.Set(RtfHeaderFooters.RIGHT_PAGES, New HeaderFooter(New Phrase("This footer is on all pages except the first. Page: "), True))
				doc.Open
				doc.Header = header
				doc.Footer = footer
				Dim chapter As Chapter = New Chapter(New Paragraph("Advanced RTF headers and footers", New Font(Font.HELVETICA, 16, Font.BOLD)), 1)
				chapter.Add(New Paragraph("This doc demonstrates the use of advanced RTF headers and footers."))
				Dim i As Integer = 0
				While i < 300
					chapter.Add(New Paragraph("Line " + i.ToString()))
					System.Math.Min(System.Threading.Interlocked.Increment(i),i-1)
				End While
				doc.Add(chapter)
			Catch de As DocumentException
				Console.Error.WriteLine(de.Message)
			Catch ioe As IOException
				Console.Error.WriteLine(ioe.Message)
			End Try
			doc.Close
		End Sub
	End Class 
End Namespace
