Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap09

	Public Class Chap0907

		Public Sub New()
			Console.WriteLine("Chapter 9 example 7: Barcodes without ttf")
			Dim doc As Document = New Document(PageSize.A4, 50, 50, 50, 50)
			Try
				Dim writer As PdfWriter = PdfWriter.GetInstance(doc, New FileStream("Chap0907.pdf", FileMode.Create))
				doc.Open
				Dim cb As PdfContentByte = writer.DirectContent
				Dim code39 As Barcode39 = New Barcode39
				code39.Code = "CODE39-1234567890"
				code39.StartStopText = False
				Dim image39 As Image = code39.CreateImageWithBarcode(cb, Nothing, Nothing)
				Dim code39ext As Barcode39 = New Barcode39
				code39ext.Code = "The willows."
				code39ext.StartStopText = False
				code39ext.Extended = True
				Dim image39ext As Image = code39ext.CreateImageWithBarcode(cb, Nothing, Nothing)
				Dim code128 As Barcode128 = New Barcode128
				code128.Code = "1Z234786 hello"
				Dim image128 As Image = code128.CreateImageWithBarcode(cb, Nothing, Nothing)
				Dim codeEAN As BarcodeEAN = New BarcodeEAN
				codeEAN.CodeType = BarcodeEAN.EAN13
				codeEAN.Code = "9780201615883"
				Dim imageEAN As Image = codeEAN.CreateImageWithBarcode(cb, Nothing, Nothing)
				Dim code25 As BarcodeInter25 = New BarcodeInter25
				code25.GenerateChecksum = True
				code25.Code = "41-1200076041-001"
				Dim image25 As Image = code25.CreateImageWithBarcode(cb, Nothing, Nothing)
				Dim codePost As BarcodePostnet = New BarcodePostnet
				codePost.Code = "12345"
				Dim imagePost As Image = codePost.CreateImageWithBarcode(cb, Nothing, Nothing)
				Dim codePlanet As BarcodePostnet = New BarcodePostnet
				codePlanet.Code = "50201402356"
				codePlanet.CodeType = BarcodePostnet.PLANET
				Dim imagePlanet As Image = codePlanet.CreateImageWithBarcode(cb, Nothing, Nothing)
				Dim tp As PdfTemplate = cb.CreateTemplate(0, 0)
				Dim ean As PdfTemplate = codeEAN.CreateTemplateWithBarcode(cb, Nothing, New Color(System.Drawing.Color.Blue))
				Dim codeSUPP As BarcodeEAN = New BarcodeEAN
				codeSUPP.CodeType = BarcodeEAN.SUPP5
				codeSUPP.Code = "54995"
				codeSUPP.Baseline = -2
				Dim eanSupp As BarcodeEANSUPP = New BarcodeEANSUPP(codeEAN, codeSUPP)
				Dim imageEANSUPP As Image = eanSupp.CreateImageWithBarcode(cb, Nothing, New Color(System.Drawing.Color.Blue))
				Dim table As PdfPTable = New PdfPTable(2)
				table.WidthPercentage = 100
				table.DefaultCell.Border = Rectangle.NO_BORDER
				table.DefaultCell.HorizontalAlignment = Element.ALIGN_CENTER
				table.DefaultCell.VerticalAlignment = Element.ALIGN_MIDDLE
				table.DefaultCell.FixedHeight = 70
				table.AddCell("CODE 39")
				table.AddCell(New Phrase(New Chunk(image39, 0, 0)))
				table.AddCell("CODE 39 EXTENDED")
				table.AddCell(New Phrase(New Chunk(image39ext, 0, 0)))
				table.AddCell("CODE 128")
				table.AddCell(New Phrase(New Chunk(image128, 0, 0)))
				table.AddCell("CODE EAN")
				table.AddCell(New Phrase(New Chunk(imageEAN, 0, 0)))
				table.AddCell("CODE EAN" & Microsoft.VisualBasic.Chr(10) & "WITH" & Microsoft.VisualBasic.Chr(10) & "SUPPLEMENTAL 5")
				table.AddCell(New Phrase(New Chunk(imageEANSUPP, 0, 0)))
				table.AddCell("CODE INTERLEAVED")
				table.AddCell(New Phrase(New Chunk(image25, 0, 0)))
				table.AddCell("CODE POSTNET")
				table.AddCell(New Phrase(New Chunk(imagePost, 0, 0)))
				table.AddCell("CODE PLANET")
				table.AddCell(New Phrase(New Chunk(imagePlanet, 0, 0)))
				doc.Add(table)
			Catch de As Exception
				Console.Error.WriteLine(de.StackTrace)
			End Try
			doc.Close
		End Sub
	End Class 
End Namespace
