Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap10

	Public Class Chap1002

		Public Sub New()
			Console.WriteLine("Chapter 10 example 2: Text at absolute positions")
			Dim doc As Document = New Document
			Try
				Dim writer As PdfWriter = PdfWriter.GetInstance(doc, New FileStream("Chap1002.pdf", FileMode.Create))
				doc.Open
				Dim cb As PdfContentByte = writer.DirectContent
				cb.SetLineWidth(0F)
				cb.MoveTo(250, 500)
				cb.LineTo(250, 800)
				cb.MoveTo(50, 700)
				cb.LineTo(400, 700)
				cb.MoveTo(50, 650)
				cb.LineTo(400, 650)
				cb.MoveTo(50, 600)
				cb.LineTo(400, 600)
				cb.Stroke
				cb.BeginText
				Dim bf As BaseFont = BaseFont.CreateFont(BaseFont.HELVETICA, BaseFont.CP1252, BaseFont.NOT_EMBEDDED)
				cb.SetFontAndSize(bf, 12)
				Dim text As String = "Sample text for alignment"
				cb.ShowTextAligned(PdfContentByte.ALIGN_CENTER, text + " Center", 250, 700, 0)
				cb.ShowTextAligned(PdfContentByte.ALIGN_RIGHT, text + " Right", 250, 650, 0)
				cb.ShowTextAligned(PdfContentByte.ALIGN_LEFT, text + " Left", 250, 600, 0)
				cb.SetTextMatrix(100, 400)
				cb.ShowText("Text at position 100,400.")
				cb.SetTextMatrix(0, 1, -1, 0, 100, 300)
				cb.ShowText("Text at position 100,300, rotated 90 degrees.")
				cb.SetTextMatrix(0, 1, 1, 0, 200, 200)
				cb.ShowText("Text at position 200,200, mirrored and rotated 90 degrees.")
				cb.EndText
			Catch de As DocumentException
				Console.Error.WriteLine(de.Message)
			Catch ioe As IOException
				Console.Error.WriteLine(ioe.Message)
			End Try
			doc.Close
		End Sub
	End Class 
End Namespace
