Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap10

	Public Class Chap1003

		Public Sub New()
			Console.WriteLine("Chapter 10 example 3: Templates")
			Dim doc As Document = New Document
			Try
				Dim writer As PdfWriter = PdfWriter.GetInstance(doc, New FileStream("Chap1003.pdf", FileMode.Create))
				doc.Open
				Dim cb As PdfContentByte = writer.DirectContent
				Dim template As PdfTemplate = cb.CreateTemplate(500, 200)
				template.MoveTo(0, 200)
				template.LineTo(500, 0)
				template.Stroke
				template.SetRGBColorStrokeF(255F, 0F, 0F)
				template.Circle(250F, 100F, 80F)
				template.Stroke
				template.BeginText
				Dim bf As BaseFont = BaseFont.CreateFont(BaseFont.HELVETICA, BaseFont.CP1252, BaseFont.NOT_EMBEDDED)
				template.SetFontAndSize(bf, 12)
				template.SetTextMatrix(100, 100)
				template.ShowText("Text at the position 100,100 (relative to the template!)")
				template.EndText
				cb.AddTemplate(template, 0, 0)
				cb.AddTemplate(template, 0, 1, -1, 0, 500, 200)
				cb.AddTemplate(template, 0.5F, 0, 0, 0.5F, 100, 400)
				doc.NewPage
				cb.AddTemplate(template, 0, 400)
				cb.AddTemplate(template, 2, 0, 0, 2, -200, 400)
			Catch de As DocumentException
				Console.Error.WriteLine(de.Message)
			Catch ioe As IOException
				Console.Error.WriteLine(ioe.Message)
			End Try
			doc.Close
		End Sub
	End Class 
End Namespace
