Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap10

	Public Class Chap1006

		Public Sub New()
			Console.WriteLine("Chapter 10 example 6: Simple Columns")
			Dim doc As Document = New Document
			Try
				Dim writer As PdfWriter = PdfWriter.GetInstance(doc, New FileStream("Chap1006.pdf", FileMode.Create))
				doc.Open
				Dim cb As PdfContentByte = writer.DirectContent
				Dim bf As BaseFont = BaseFont.CreateFont(BaseFont.COURIER, BaseFont.CP1252, BaseFont.NOT_EMBEDDED)
				Dim font As Font = New Font(bf, 11, Font.NORMAL)
				Dim ct As ColumnText = New ColumnText(cb)
				ct.SetSimpleColumn(60, 300, 100, 300 + 28 * 15, 15, Element.ALIGN_CENTER)
				ct.AddText(New Phrase(15, "UNI" & Microsoft.VisualBasic.Chr(10) & "", font))
				Dim i As Integer = 0
				While i < 27
					ct.AddText(New Phrase(15, uni(i) + "" & Microsoft.VisualBasic.Chr(10) & "", font))
					System.Math.Min(System.Threading.Interlocked.Increment(i),i-1)
				End While
				ct.Go
				cb.Rectangle(103, 295, 52, 8 + 28 * 15)
				cb.Stroke
				ct.SetSimpleColumn(105, 300, 150, 300 + 28 * 15, 15, Element.ALIGN_RIGHT)
				ct.AddText(New Phrase(15, "char" & Microsoft.VisualBasic.Chr(10) & "", font))
				i = 0
				While i < 27
					ct.AddText(New Phrase(15, code(i) + "" & Microsoft.VisualBasic.Chr(10) & "", font))
					System.Math.Min(System.Threading.Interlocked.Increment(i),i-1)
				End While
				ct.Go
				ct.SetSimpleColumn(160, 300, 500, 300 + 28 * 15, 15, Element.ALIGN_LEFT)
				ct.AddText(New Phrase(15, "NAME" & Microsoft.VisualBasic.Chr(10) & "", font))
				i = 0
				While i < 27
					ct.AddText(New Phrase(15, name(i) + "" & Microsoft.VisualBasic.Chr(10) & "", font))
					System.Math.Min(System.Threading.Interlocked.Increment(i),i-1)
				End While
				ct.Go
			Catch de As DocumentException
				Console.Error.WriteLine(de.Message)
			Catch ioe As IOException
				Console.Error.WriteLine(ioe.Message)
			End Try
			doc.Close
		End Sub
		Public Shared uni As String() = New String(27) {}
		Public Shared code As String() = New String(27) {}
		Public Shared name As String() = New String(27) {}

		Shared Sub New()
			uni(0) = "\u0152"
			code(0) = "Đ"
			name(0) = "LATIN CAPITAL LIGATURE OE"
			uni(1) = "\u0153"
			code(1) = "ŀ"
			name(1) = "LATIN SMALL LIGATURE OE"
			uni(2) = "\u0160"
			code(2) = "Ð"
			name(2) = "LATIN CAPITAL LETTER S WITH CARON"
			uni(3) = "\u0161"
			code(3) = "Ā"
			name(3) = "LATIN SMALL LETTER S WITH CARON"
			uni(4) = "\u0178"
			code(4) = "ɰ"
			name(4) = "LATIN CAPITAL LETTER Y WITH DIAERESIS"
			uni(5) = "\u017D"
			code(5) = "͠"
			name(5) = "LATIN CAPITAL LETTER Z WITH CARON"
			uni(6) = "\u017E"
			code(6) = "ΐ"
			name(6) = "LATIN SMALL LETTER Z WITH CARON"
			uni(7) = "\u0192"
			code(7) = "Ɛ"
			name(7) = "LATIN SMALL LETTER F WITH HOOK"
			uni(8) = "\u02C6"
			code(8) = "ˀ"
			name(8) = "MODIFIER LETTER CIRCUMFLEX ACCENT"
			uni(9) = "\u02DC"
			code(9) = "Ѐ"
			name(9) = "SMALL TILDE"
			uni(10) = "\u2013"
			code(10) = "²"
			name(10) = "EN DASH"
			uni(11) = "\u2014"
			code(11) = "â"
			name(11) = "EM DASH"
			uni(12) = "\u2018"
			code(12) = "Ƣ"
			name(12) = "LEFT SINGLE QUOTATION MARK"
			uni(13) = "\u2019"
			code(13) = "ǒ"
			name(13) = "RIGHT SINGLE QUOTATION MARK"
			uni(14) = "\u201A"
			code(14) = "Ȃ"
			name(14) = "SINGLE LOW-9 QUOTATION MARK"
			uni(15) = "\u201C"
			code(15) = "ɢ"
			name(15) = "LEFT DOUBLE QUOTATION MARK"
			uni(16) = "\u201D"
			code(16) = "ʒ"
			name(16) = "RIGHT DOUBLE QUOTATION MARK"
			uni(17) = "\u201E"
			code(17) = "˂"
			name(17) = "DOUBLE LOW-9 QUOTATION MARK"
			uni(18) = "\u2020"
			code(18) = "B"
			name(18) = "DAGGER"
			uni(19) = "\u2021"
			code(19) = "r"
			name(19) = "DOUBLE DAGGER"
			uni(20) = "\u2022"
			code(20) = "¢"
			name(20) = "BULLET"
			uni(21) = "\u2026"
			code(21) = "Ţ"
			name(21) = "HORIZONTAL ELLIPSIS"
			uni(22) = "\u2030"
			code(22) = "b"
			name(22) = "PER MILLE SIGN"
			uni(23) = "\u2039"
			code(23) = "Ȓ"
			name(23) = "SINGLE LEFT-POINTING ANGLE QUOTATION MARK"
			uni(24) = "\u203A"
			code(24) = "ɂ"
			name(24) = "SINGLE RIGHT-POINTING ANGLE QUOTATION MARK"
			uni(25) = "\u20AC"
			code(25) = "΂"
			name(25) = "EURO SIGN"
			uni(26) = "\u2122"
			code(26) = "²"
			name(26) = "TRADE MARK SIGN"
		End Sub
	End Class 
End Namespace
