Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap10

	Public Class Chap1008

		Public Sub New()
			Console.WriteLine("Chapter 10 example 8: Irregular columns")
			Dim doc As Document = New Document
			Try
				Dim writer As PdfWriter = PdfWriter.GetInstance(doc, New FileStream("Chap1008.pdf", FileMode.Create))
				doc.Open
				Dim bf As BaseFont = BaseFont.CreateFont(BaseFont.HELVETICA, BaseFont.CP1252, BaseFont.NOT_EMBEDDED)
				Dim font As Font = New Font(bf, 11, Font.NORMAL)
				Dim cb As PdfContentByte = writer.DirectContent
				Dim t As PdfTemplate = cb.CreateTemplate(600, 800)
				Dim caesar As Image = Image.GetInstance("caesar_coin.jpg")
				cb.AddImage(caesar, 100, 0, 0, 100, 260, 595)
				t.SetGrayFill(0.75F)
				t.MoveTo(310, 112)
				t.LineTo(280, 60)
				t.LineTo(340, 60)
				t.ClosePath
				t.MoveTo(310, 790)
				t.LineTo(310, 710)
				t.MoveTo(310, 580)
				t.LineTo(310, 122)
				t.Stroke
				cb.AddTemplate(t, 0, 0)
				Dim ct As ColumnText = New ColumnText(cb)
				ct.AddText(New Phrase("GALLIA est omnis divisa in partes tres, quarum unam incolunt Belgae, aliam Aquitani, tertiam qui ipsorum lingua Celtae, nostra Galli appellantur.  Hi omnes lingua, institutis, legibus inter se differunt. Gallos ab Aquitanis Garumna flumen, a Belgis Matrona et Sequana dividit. Horum omnium fortissimi sunt Belgae, propterea quod a cultu atque humanitate provinciae longissime absunt, minimeque ad eos mercatores saepe commeant atque ea quae ad effeminandos animos pertinent important, proximique sunt Germanis, qui trans Rhenum incolunt, quibuscum continenter bellum gerunt.  Qua de causa Helvetii quoque reliquos Gallos virtute praecedunt, quod fere cotidianis proeliis cum Germanis contendunt, cum aut suis finibus eos prohibent aut ipsi in eorum finibus bellum gerunt." & Microsoft.VisualBasic.Chr(10) & "", FontFactory.GetFont(FontFactory.HELVETICA, 12)))
				ct.AddText(New Phrase("[Eorum una, pars, quam Gallos obtinere dictum est, initium capit a flumine Rhodano, continetur Garumna flumine, Oceano, finibus Belgarum, attingit etiam ab Sequanis et Helvetiis flumen Rhenum, vergit ad septentriones. Belgae ab extremis Galliae finibus oriuntur, pertinent ad inferiorem partem fluminis Rheni, spectant in septentrionem et orientem solem. Aquitania a Garumna flumine ad Pyrenaeos montes et eam partem Oceani quae est ad Hispaniam pertinet; spectat inter occasum solis et septentriones.]" & Microsoft.VisualBasic.Chr(10) & "", FontFactory.GetFont(FontFactory.HELVETICA, 12)))
				ct.AddText(New Phrase("Apud Helvetios longe nobilissimus fuit et ditissimus Orgetorix.  Is M. Messala, [et P.] M.  Pisone consulibus regni cupiditate inductus coniurationem nobilitatis fecit et civitati persuasit ut de finibus suis cum omnibus copiis exirent:  perfacile esse, cum virtute omnibus praestarent, totius Galliae imperio potiri.  Id hoc facilius iis persuasit, quod undique loci natura Helvetii continentur:  una ex parte flumine Rheno latissimo atque altissimo, qui agrum Helvetium a Germanis dividit; altera ex parte monte Iura altissimo, qui est inter Sequanos et Helvetios; tertia lacu Lemanno et flumine Rhodano, qui provinciam nostram ab Helvetiis dividit.  His rebus fiebat ut et minus late vagarentur et minus facile finitimis bellum inferre possent; qua ex parte homines bellandi cupidi magno dolore adficiebantur.  Pro multitudine autem hominum et pro gloria belli atque fortitudinis angustos se fines habere arbitrabantur, qui in longitudinem milia passuum CCXL, in latitudinem CLXXX patebant." & Microsoft.VisualBasic.Chr(10) & "", FontFactory.GetFont(FontFactory.HELVETICA, 12)))
				ct.AddText(New Phrase("His rebus adducti et auctoritate Orgetorigis permoti constituerunt ea quae ad proficiscendum pertinerent comparare, iumentorum et carrorum quam maximum numerum coemere, sementes quam maximas facere, ut in itinere copia frumenti suppeteret, cum proximis civitatibus pacem et amicitiam confirmare.  Ad eas res conficiendas biennium sibi satis esse duxerunt; in tertium annum profectionem lege confirmant.  Ad eas res conficiendas Orgetorix deligitur.  Is sibi legationem ad civitates suscipit.  In eo itinere persuadet Castico, Catamantaloedis filio, Sequano, cuius pater regnum in Sequanis multos annos obtinuerat et a senatu populi Romani amicus appellatus erat, ut regnum in civitate sua occuparet, quod pater ante habuerit; itemque Dumnorigi Haeduo, fratri Diviciaci, qui eo tempore principatum in civitate obtinebat ac maxime plebi acceptus erat, ut idem conaretur persuadet eique filiam suam in matrimonium dat.  Perfacile factu esse illis probat conata perficere, propterea quod ipse suae civitatis imperium obtenturus esset:  non esse dubium quin totius Galliae plurimum Helvetii possent; se suis copiis suoque exercitu illis regna conciliaturum confirmat.  Hac oratione adducti inter se fidem et ius iurandum dant et regno occupato per tres potentissimos ac firmissimos populos totius Galliae sese potiri posse sperant." & Microsoft.VisualBasic.Chr(10) & "", FontFactory.GetFont(FontFactory.HELVETICA, 12)))
				ct.AddText(New Phrase("Ea res est Helvetiis per indicium enuntiata.  Moribus suis Orgetoricem ex vinculis causam dicere coegerunt; damnatum poenam sequi oportebat, ut igni cremaretur.  Die constituta causae dictionis Orgetorix ad iudicium omnem suam familiam, ad hominum milia decem, undique coegit, et omnes clientes obaeratosque suos, quorum magnum numerum habebat, eodem conduxit; per eos ne causam diceret se eripuit.  Cum civitas ob eam rem incitata armis ius suum exequi conaretur multitudinemque hominum ex agris magistratus cogerent, Orgetorix mortuus est; neque abest suspicio, ut Helvetii arbitrantur, quin ipse sibi mortem consciverit.", FontFactory.GetFont(FontFactory.HELVETICA, 12)))
				Dim left1 As Single() =  {70, 790, 70, 60}
				Dim right1 As Single() =  {300, 790, 300, 700, 240, 700, 240, 590, 300, 590, 300, 106, 270, 60}
				Dim left2 As Single() =  {320, 790, 320, 700, 380, 700, 380, 590, 320, 590, 320, 106, 350, 60}
				Dim right2 As Single() =  {550, 790, 550, 60}
				Dim status As Integer = 0
				Dim column As Integer = 0
				While (status And ColumnText.NO_MORE_TEXT) = 0
					If column = 0 Then
						ct.SetColumns(left1, right1)
						column = 1
					Else
						ct.SetColumns(left2, right2)
						column = 0
					End If
					status = ct.Go
					ct.YLine = 790
					ct.Alignment = Element.ALIGN_JUSTIFIED
					status = ct.Go
					If (column = 0) AndAlso (Not ((status And ColumnText.NO_MORE_COLUMN) = 0)) Then
						doc.NewPage
						cb.AddTemplate(t, 0, 0)
						cb.AddImage(caesar, 100, 0, 0, 100, 260, 595)
					End If
				End While
				doc.Close
			Catch de As DocumentException
				Console.Error.WriteLine(de.Message)
			Catch ioe As IOException
				Console.Error.WriteLine(ioe.Message)
			End Try
		End Sub
	End Class 
End Namespace
