Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap10

	Public Class Chap1011

		Public Sub New()
			Console.WriteLine("Chapter 10 example 11: a PdfPTable in a template")
			Dim rect As Rectangle = New Rectangle(PageSize.A4)
			rect.BackgroundColor = New Color(238, 221, 88)
			Dim doc As Document = New Document(rect, 50, 50, 50, 50)
			Try
				Dim writer As PdfWriter = PdfWriter.GetInstance(doc, New FileStream("Chap1011.pdf", FileMode.Create))
				doc.Open
				Dim template As PdfTemplate = writer.DirectContent.CreateTemplate(20, 20)
				Dim bf As BaseFont = BaseFont.CreateFont(BaseFont.HELVETICA, BaseFont.WINANSI, BaseFont.NOT_EMBEDDED)
				Dim text As String = "Vertical"
				Dim size As Single = 16
				Dim width As Single = bf.GetWidthPoint(text, size)
				template.BeginText
				template.SetRGBColorFillF(1, 1, 1)
				template.SetFontAndSize(bf, size)
				template.SetTextMatrix(0, 2)
				template.ShowText(text)
				template.EndText
				template.Width = width
				template.Height = size + 2
				Dim img As Image = Image.GetInstance(template)
				img.RotationDegrees = 90
				Dim ck As Chunk = New Chunk(img, 0, 0)
				Dim table As PdfPTable = New PdfPTable(3)
				table.WidthPercentage = 100
				table.DefaultCell.HorizontalAlignment = Element.ALIGN_CENTER
				table.DefaultCell.VerticalAlignment = Element.ALIGN_MIDDLE
				Dim cell As PdfPCell = New PdfPCell(img)
				cell.Padding = 4
				cell.BackgroundColor = New Color(0, 0, 255)
				cell.HorizontalAlignment = Element.ALIGN_CENTER
				table.AddCell("I see a template on my right")
				table.AddCell(cell)
				table.AddCell("I see a template on my left")
				table.AddCell(cell)
				table.AddCell("I see a template everywhere")
				table.AddCell(cell)
				table.AddCell("I see a template on my right")
				table.AddCell(cell)
				table.AddCell("I see a template on my left")
				Dim p1 As Paragraph = New Paragraph("This is a template ")
				p1.Add(ck)
				p1.Add(" just here.")
				p1.Leading = img.ScaledHeight * 1.1F
				doc.Add(p1)
				doc.Add(table)
				Dim p2 As Paragraph = New Paragraph("More templates ")
				p2.Leading = img.ScaledHeight * 1.1F
				p2.Alignment = Element.ALIGN_JUSTIFIED
				img.ScalePercent(70)
				Dim k As Integer = 0
				While k < 20
					p2.Add(ck)
					System.Threading.Interlocked.Increment(k)
				End While
				doc.Add(p2)
				doc.Close
			Catch de As Exception
				Console.Error.WriteLine(de.Message)
				Console.Error.WriteLine(de.StackTrace)
			End Try
		End Sub
	End Class 
End Namespace
