Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap10

	Public Class Chap1013

		Public Sub New()
			Console.WriteLine("Chapter 10 Example 13: Spot Color")
			Dim doc As Document = New Document
			Try
				Dim writer As PdfWriter = PdfWriter.GetInstance(doc, New FileStream("Chap1013.pdf", FileMode.Create))
				Dim bf As BaseFont = BaseFont.CreateFont("Helvetica", "winansi", BaseFont.NOT_EMBEDDED)
				doc.Open
				Dim cb As PdfContentByte = writer.DirectContent
				Dim spc_cmyk As PdfSpotColor = New PdfSpotColor("PANTONE 280 CV", 0.25F, New CMYKColor(0.9F, 0.2F, 0.3F, 0.1F))
				Dim spc_rgb As PdfSpotColor = New PdfSpotColor("PANTONE 147", 0.9F, New Color(114, 94, 38))
				Dim spc_g As PdfSpotColor = New PdfSpotColor("PANTONE 100 CV", 0.5F, New GrayColor(0.9F))
				cb.SetColorStroke(spc_cmyk, 0.5F)
				cb.SetLineWidth(10F)
				cb.Rectangle(100, 700, 100, 100)
				cb.MoveTo(100, 700)
				cb.LineTo(200, 800)
				cb.Stroke
				cb.SetColorFill(spc_cmyk, spc_cmyk.Tint)
				cb.Rectangle(250, 700, 100, 100)
				cb.Fill
				cb.SetColorStroke(spc_rgb, spc_rgb.Tint)
				cb.SetLineWidth(5F)
				cb.Circle(150F, 500F, 100F)
				cb.Stroke
				cb.SetColorFill(spc_rgb, spc_rgb.Tint)
				cb.Circle(150F, 500F, 50F)
				cb.Fill
				cb.SetColorFill(spc_g, spc_g.Tint)
				cb.MoveTo(100F, 200F)
				cb.LineTo(200F, 250F)
				cb.LineTo(400F, 150F)
				cb.Fill
				doc.NewPage
				Dim text As String = "Some text to show"
				doc.Add(New Paragraph(text, FontFactory.GetFont(FontFactory.HELVETICA, 24, Font.NORMAL, New SpotColor(spc_cmyk))))
				doc.Add(New Paragraph(text, FontFactory.GetFont(FontFactory.HELVETICA, 24, Font.NORMAL, New SpotColor(spc_cmyk, 0.5F))))
				Dim t As PdfTemplate = cb.CreateTemplate(500F, 500F)
				t.SetColorStroke(New SpotColor(spc_cmyk, 0.5F))
				t.SetLineWidth(10F)
				t.Rectangle(100, 10, 100, 100)
				t.MoveTo(100, 10)
				t.LineTo(200, 100)
				t.Stroke
				t.SetColorFill(spc_g, spc_g.Tint)
				t.Rectangle(100, 125, 100, 100)
				t.Fill
				t.BeginText
				t.SetFontAndSize(bf, 20F)
				t.SetTextMatrix(1F, 0F, 0F, 1F, 10F, 10F)
				t.ShowText("Template text upside down")
				t.EndText
				t.Rectangle(0, 0, 499, 499)
				t.Stroke
				cb.AddTemplate(t, -1F, 0F, 0F, -1F, 550F, 550F)
			Catch de As Exception
				Console.Error.WriteLine(de.Message)
				Console.Error.WriteLine(de.StackTrace)
			End Try
			doc.Close
		End Sub
	End Class 
End Namespace
