Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap11

	Public Class Chap1102

		Public Sub New()
			Console.WriteLine("Chapter 11 example 2: anchor and remote goto")
			Dim document As Document = New Document
			Try
				Dim writerA As PdfWriter = PdfWriter.GetInstance(document, New FileStream("Chap1102a.pdf", FileMode.Create))
				Dim writerB As PdfWriter = PdfWriter.GetInstance(document, New FileStream("Chap1102b.pdf", FileMode.Create))
				document.Open
				Dim p1 As Paragraph = New Paragraph("We discussed anchors in chapter 3, but you can add an URL to a chunk to to make it an ", FontFactory.GetFont(FontFactory.HELVETICA, 12))
				p1.Add((New Chunk("anchor", FontFactory.GetFont(FontFactory.HELVETICA, 12, Font.UNDERLINE, New Color(0, 0, 255)))).SetAnchor(New Uri("http://iTextSharp.Sourceforge.Net")))
				p1.Add(" you will automatically jump to another location in this document.")
				Dim p2 As Paragraph = New Paragraph("blah, blah, blah")
				Dim p3a As Paragraph = New Paragraph("This paragraph contains a ")
				p3a.Add((New Chunk("local destination in document A", FontFactory.GetFont(FontFactory.HELVETICA, 12, Font.NORMAL, New Color(0, 255, 0)))).SetLocalDestination("test"))
				Dim p3b As Paragraph = New Paragraph("This paragraph contains a local ")
				p3b.Add((New Chunk("local destination in document B", FontFactory.GetFont(FontFactory.HELVETICA, 12, Font.NORMAL, New Color(0, 255, 0)))).SetLocalDestination("test"))
				Dim p4a As Paragraph = New Paragraph((New Chunk("Click this paragraph to go to a certain destination on document B")).SetRemoteGoto("Chap1102b.pdf", "test"))
				Dim p4b As Paragraph = New Paragraph((New Chunk("Click this paragraph to go to a certain destination on document A")).SetRemoteGoto("Chap1102a.pdf", "test"))
				Dim p5a As Paragraph = New Paragraph("you can also jump to a ")
				p5a.Add((New Chunk("specific page on another document", FontFactory.GetFont(FontFactory.HELVETICA, 12, Font.ITALIC))).SetRemoteGoto("Chap1102b.pdf", 3))
				document.Add(p1)
				document.Add(p2)
				document.Add(p2)
				document.Add(p2)
				document.Add(p2)
				document.Add(p2)
				document.Add(p2)
				document.Add(p2)
				writerA.Pause
				document.Add(p4b)
				writerA.Resume
				writerB.Pause
				document.Add(p4a)
				document.Add(p5a)
				writerB.Resume
				document.Add(p2)
				document.Add(p2)
				document.Add(p2)
				document.Add(p2)
				writerA.Pause
				document.Add(p3b)
				document.Add(p2)
				document.Add(p2)
				document.NewPage
				document.Add(p2)
				document.Add(p2)
				document.NewPage
				writerA.Resume
				writerB.Pause
				document.Add(p3a)
				writerB.Resume
				document.Add(p2)
				document.Add(p2)
			Catch de As DocumentException
				Console.Error.WriteLine(de.Message)
			Catch ioe As IOException
				Console.Error.WriteLine(ioe.Message)
			Catch e As Exception
				Console.Error.WriteLine(e.Message)
			End Try
			document.Close
		End Sub
	End Class 
End Namespace
