Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap11

	Public Class Chap1103

		Public Sub New()
			Console.WriteLine("Chapter 11 example 3: named actions")
			Dim document As Document = New Document(PageSize.A4, 50, 50, 50, 50)
			Try
				Dim writer As PdfWriter = PdfWriter.GetInstance(document, New FileStream("Chap1103.pdf", FileMode.Create))
				document.Open
				Dim application As String = "c:/winnt/notepad.exe"
				Dim p As Paragraph = New Paragraph((New Chunk("Click to open " + application)).SetAction(New PdfAction(application, Nothing, Nothing, Nothing)))
				Dim table As PdfPTable = New PdfPTable(4)
				table.DefaultCell.HorizontalAlignment = Element.ALIGN_CENTER
				table.AddCell(New Phrase((New Chunk("First Page")).SetAction(New PdfAction(PdfAction.FIRSTPAGE))))
				table.AddCell(New Phrase((New Chunk("Prev Page")).SetAction(New PdfAction(PdfAction.PREVPAGE))))
				table.AddCell(New Phrase((New Chunk("Next Page")).SetAction(New PdfAction(PdfAction.NEXTPAGE))))
				table.AddCell(New Phrase((New Chunk("Last Page")).SetAction(New PdfAction(PdfAction.LASTPAGE))))
				Dim k As Integer = 1
				While k <= 10
					document.Add(New Paragraph("This is page " + k.ToString()))
					document.Add(table)
					document.Add(p)
					document.NewPage
					System.Threading.Interlocked.Increment(k)
				End While
			Catch de As Exception
				Console.Error.WriteLine(de.StackTrace)
				Console.Error.WriteLine(de.Message)
			End Try
			document.Close
		End Sub
	End Class 
End Namespace
