Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap11

	Public Class Chap1107

		Public Sub New()
			Console.WriteLine("Chapter 11 example 7: Outlines and Destinations")
			Dim document As Document = New Document
			Try
				Dim writer As PdfWriter = PdfWriter.GetInstance(document, New FileStream("Chap1107.pdf", FileMode.Create))
				document.Open
				Dim cb As PdfContentByte = writer.DirectContent
				Dim template As PdfTemplate = cb.CreateTemplate(25, 25)
				template.MoveTo(13, 0)
				template.LineTo(13, 25)
				template.MoveTo(0, 13)
				template.LineTo(50, 13)
				template.Stroke
				cb.AddTemplate(template, 287, 787)
				cb.AddTemplate(template, 187, 487)
				cb.AddTemplate(template, 487, 287)
				cb.AddTemplate(template, 87, 87)
				Dim d1 As PdfDestination = New PdfDestination(PdfDestination.XYZ, 300, 800, 0)
				Dim d2 As PdfDestination = New PdfDestination(PdfDestination.FITH, 500)
				Dim d3 As PdfDestination = New PdfDestination(PdfDestination.FITR, 200, 300, 400, 500)
				Dim d4 As PdfDestination = New PdfDestination(PdfDestination.FITBV, 100)
				Dim d5 As PdfDestination = New PdfDestination(PdfDestination.FIT)
				Dim out1 As PdfOutline = New PdfOutline(cb.RootOutline, d1, "root")
				Dim out2 As PdfOutline = New PdfOutline(out1, d2, "sub 1")
				Dim out3 As PdfOutline = New PdfOutline(out1, d3, "sub 2")
				Dim out4 As PdfOutline = New PdfOutline(out2, d4, "sub 2.1")
				Dim out5 As PdfOutline = New PdfOutline(out2, d5, "sub 2.2")
				cb.AddOutline(out1)
				cb.AddOutline(out2)
				cb.AddOutline(out3)
				cb.AddOutline(out4)
				cb.AddOutline(out5)
			Catch de As DocumentException
				Console.Error.WriteLine(de.Message)
			Catch ioe As IOException
				Console.Error.WriteLine(ioe.Message)
			End Try
			document.Close
		End Sub
	End Class 
End Namespace
