Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap11

	Public Class Chap1110

		Public Sub New()
			Console.WriteLine("Chapter 11 example 10: page labels")
			Dim document As Document = New Document(PageSize.A4, 50, 50, 50, 50)
			Try
				Dim writer As PdfWriter = PdfWriter.GetInstance(document, New FileStream("Chap1110.pdf", FileMode.Create))
				document.Open
				Dim k As Integer = 1
				While k <= 10
					document.Add(New Paragraph("This document has the logical page numbers: i,ii,iii,iv,1,2,3,A-8,A-9,A-10" & Microsoft.VisualBasic.Chr(10) & "Real page " + k))
					document.NewPage
					System.Threading.Interlocked.Increment(k)
				End While
				Dim pageLabels As PdfPageLabels = New PdfPageLabels
				pageLabels.AddPageLabel(1, PdfPageLabels.LOWERCASE_ROMAN_NUMERALS)
				pageLabels.AddPageLabel(5, PdfPageLabels.DECIMAL_ARABIC_NUMERALS)
				pageLabels.AddPageLabel(8, PdfPageLabels.DECIMAL_ARABIC_NUMERALS, "A-", 8)
				writer.PageLabels = pageLabels
			Catch de As Exception
				Console.Error.WriteLine(de.Message)
				Console.Error.WriteLine(de.StackTrace)
			End Try
			document.Close
		End Sub
	End Class 
End Namespace
