Imports System
Imports System.IO
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Namespace iTextSharp.tutorial.Chap13

	Public Class Chap13_form

		Public Sub New()
			Console.WriteLine("Chapter 13: a form with some text")
			Dim document As Document = New Document(PageSize.A4, 50, 50, 50, 50)
			Try
				Dim writer As PdfWriter = PdfWriter.GetInstance(document, New FileStream("Chap13_form.pdf", FileMode.Create))
				Dim acroForm As PdfAcroForm = writer.AcroForm
				document.Open
				Dim helv As BaseFont = BaseFont.CreateFont(BaseFont.HELVETICA, BaseFont.WINANSI, BaseFont.NOT_EMBEDDED)
				Dim fontSize As Single = 12
				acroForm.AddSingleLineTextField("name", "your name", helv, fontSize, 171, 800, 350, 820)
				acroForm.AddMultiLineTextField("msg", "Hello iText!" & Microsoft.VisualBasic.Chr(10) & "This is a Test" & Microsoft.VisualBasic.Chr(10) & "There are multiple lines in this textfield", helv, fontSize, 171, 730, 350, 790)
				acroForm.AddSingleLinePasswordField("password", "", helv, fontSize, 171, 700, 350, 720)
				acroForm.AddHtmlPostButton("btn", "SUBMIT", "noValue", "Chap13.php", helv, fontSize, 355, 700, 420, 725)
				acroForm.AddResetButton("reset", "RESET", Nothing, helv, fontSize, 430, 700, 495, 725)
				acroForm.AddCheckBox("CB1", "Food", True, 180, 685, 190, 695)
				acroForm.AddCheckBox("CB2", "Drinks", False, 180, 645, 210, 675)
				Dim radiogroup As PdfFormField = acroForm.GetRadioGroup("CreditCard", "Visa", True)
				acroForm.AddRadioButton(radiogroup, "Visa", 180, 625, 195, 640)
				acroForm.AddRadioButton(radiogroup, "MasterCard", 200, 625, 215, 640)
				acroForm.AddRadioButton(radiogroup, "American", 220, 625, 235, 640)
				acroForm.AddRadioGroup(radiogroup)
				Dim colors As String() =  {"Red", "Green", "Blue"}
				Dim colorvalues As String(,) =  { {"#FF0000", "Red"},  {"#00FF00", "Green"},  {"#0000FF", "Blue"}}
				acroForm.AddSelectList("list1", colors, "Green", helv, fontSize, 171, 550, 300, 600)
				acroForm.AddSelectList("list2", colorvalues, "#0000FF", helv, fontSize, 315, 550, 450, 600)
				acroForm.AddComboBox("combo1", colors, "Green", True, helv, fontSize, 171, 440, 300, 490)
				acroForm.AddComboBox("combo2", colorvalues, "#0000FE", False, helv, fontSize, 315, 440, 450, 490)
				Dim cb As PdfContentByte = New PdfContentByte(Nothing)
				cb.SetRGBColorStroke(0, 0, 0)
				cb.SetRGBColorFill(255, 0, 0)
				cb.Arc(0, 0, 100, 100, 0, 360)
				cb.FillStroke
				cb.SetRGBColorStroke(0, 0, 0)
				cb.SetRGBColorFill(255, 255, 255)
				cb.Arc(20, 20, 80, 80, 0, 360)
				cb.FillStroke
				cb.SetRGBColorStroke(0, 0, 0)
				cb.SetRGBColorFill(255, 0, 0)
				cb.Arc(40, 40, 60, 60, 0, 360)
				cb.FillStroke
				cb.SetRGBColorFill(0, 0, 0)
				cb.Arc(48, 48, 52, 52, 0, 360)
				cb.Fill
				acroForm.AddMap("map", Nothing, "Chap13.php", cb, 171, 300, 271, 400)
				acroForm.AddHiddenField("hidden", "secret")
			Catch de As DocumentException
				Console.Error.WriteLine(de.Message)
			Catch ioe As IOException
				Console.Error.WriteLine(ioe.Message)
			End Try
			document.Close
		End Sub
	End Class 
End Namespace
